import{S as bm,i as wm,s as ym,e as n,k as c,w as u,t as s,M as Em,c as a,d as o,m as d,a as i,x as g,h as l,b as r,N as P,f as gm,G as e,g as p,y as _,q as v,o as b,B as w,v as $m,L as vm}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as Y}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as ie}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as Wt}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as _m}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function km(Vt){let $,A,k,y,N;return y=new ie({props:{code:`# !pip install opencv-python transformers accelerate
from diffusers import StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
from diffusers.utils import load_image
import numpy as np
import torch

import cv2
from PIL import Image

# download an image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)
image = np.array(image)

# get canny image
image = cv2.Canny(image, 100, 200)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)

# load control net and stable diffusion v1-5
controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)

# speed up diffusion process with faster scheduler and memory optimization
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
# remove following line if xformers is not installed
pipe.enable_xformers_memory_efficient_attention()

pipe.enable_model_cpu_offload()

# generate image
generator = torch.manual_seed(0)
image = pipe(
    "futuristic-looking woman", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># !pip install opencv-python transformers accelerate</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> cv2
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># download an image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = load_image(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.array(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># get canny image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = cv2.Canny(image, <span class="hljs-number">100</span>, <span class="hljs-number">200</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = image[:, :, <span class="hljs-literal">None</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>canny_image = Image.fromarray(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load control net and stable diffusion v1-5</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionControlNetPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># speed up diffusion process with faster scheduler and memory optimization</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># remove following line if xformers is not installed</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention()

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># generate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>generator = torch.manual_seed(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;futuristic-looking woman&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
<span class="hljs-meta">... </span>).images[<span class="hljs-number">0</span>]`}}),{c(){$=n("p"),A=s("Examples:"),k=c(),u(y.$$.fragment)},l(m){$=a(m,"P",{});var D=i($);A=l(D,"Examples:"),D.forEach(o),k=d(m),g(y.$$.fragment,m)},m(m,D){p(m,$,D),e($,A),p(m,k,D),_(y,m,D),N=!0},p:vm,i(m){N||(v(y.$$.fragment,m),N=!0)},o(m){b(y.$$.fragment,m),N=!1},d(m){m&&o($),m&&o(k),w(y,m)}}}function Cm(Vt){let $,A,k,y,N;return y=new ie({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){$=n("p"),A=s("Examples:"),k=c(),u(y.$$.fragment)},l(m){$=a(m,"P",{});var D=i($);A=l(D,"Examples:"),D.forEach(o),k=d(m),g(y.$$.fragment,m)},m(m,D){p(m,$,D),e($,A),p(m,k,D),_(y,m,D),N=!0},p:vm,i(m){N||(v(y.$$.fragment,m),N=!0)},o(m){b(y.$$.fragment,m),N=!1},d(m){m&&o($),m&&o(k),w(y,m)}}}function Pm(Vt){let $,A,k,y,N,m,D,an,sr,Ra,Z,re,rn,Be,lr,sn,cr,Ha,Ke,Ye,dr,fr,Wa,Bt,pr,Va,Kt,mr,Ba,Yt,ln,hr,Ka,se,ur,Ze,gr,_r,Ya,Zt,vr,Za,le,cn,Je,br,wr,dn,Qe,yr,Ja,J,ce,fn,Xe,Er,pn,$r,Qa,de,mn,Q,hn,kr,Cr,un,Pr,Dr,Jt,xr,Nr,gn,X,_n,et,Tr,Sr,vn,bn,Ar,Ir,Qt,tt,Mr,Xa,ee,fe,wn,ot,jr,yn,Lr,ei,pe,qr,En,Ur,Or,ti,me,$n,kn,Cn,Gr,Fr,Pn,Xt,nt,zr,eo,Rr,Hr,oi,he,Wr,at,Vr,Br,ni,it,ai,to,oo,dd,ii,z,Kr,Dn,Yr,Zr,no,Jr,Qr,ri,ao,Xr,si,rt,li,io,es,ci,st,di,ro,ts,fi,lt,pi,so,os,mi,lo,co,fd,hi,ue,ns,fo,as,is,ui,ct,gi,ge,rs,po,ss,ls,_i,dt,vi,mo,cs,bi,ft,wi,ho,ds,yi,uo,go,pd,Ei,_e,xn,fs,ps,_o,ms,$i,te,ve,Nn,pt,hs,Tn,us,ki,R,gs,Sn,_s,vs,An,bs,ws,Ci,be,ys,mt,Es,$s,Pi,oe,we,In,ht,ks,Mn,Cs,Di,ye,jn,I,Ln,Ps,Ds,qn,xs,Ns,Un,Ts,Ss,On,As,Is,C,M,Ee,ut,Ms,js,Ls,Gn,qs,Us,Fn,Os,Gs,zn,vo,$e,md,Fs,Rn,bo,wo,hd,zs,j,ke,gt,Rs,Hs,Ws,Hn,Vs,Bs,Wn,Ks,Ys,Vn,yo,Eo,ud,Zs,Bn,$o,ko,gd,Js,L,Ce,_t,Qs,Xs,el,Kn,tl,ol,Yn,nl,al,Zn,Co,Po,_d,il,Jn,Do,xo,vd,rl,q,Pe,vt,sl,ll,cl,Qn,dl,fl,Xn,pl,ml,ea,No,To,bd,hl,ta,So,Ao,wd,ul,U,De,bt,gl,_l,vl,oa,bl,wl,wt,yl,yt,El,$l,kl,na,Io,Mo,yd,Cl,aa,jo,Lo,Ed,Pl,O,xe,Et,Dl,xl,Nl,ia,Tl,Sl,$t,Al,kt,Il,Ml,jl,ra,qo,Uo,$d,Ll,sa,Oo,Go,kd,ql,G,Ne,Ct,Ul,Ol,Gl,la,Fl,zl,ca,Rl,Hl,da,Fo,zo,Cd,Wl,fa,Ro,Ho,Pd,Vl,F,Pt,Dt,Bl,Kl,pa,Yl,Zl,xt,Jl,Nt,Ql,Xl,ec,ma,Wo,Vo,Dd,tc,ha,Bo,Ko,xd,xi,ne,Te,ua,Tt,oc,ga,nc,Ni,h,St,ac,_a,ic,rc,At,sc,Yo,lc,cc,dc,H,It,fc,va,pc,mc,Se,hc,W,Mt,uc,ba,gc,_c,wa,vc,bc,Ae,jt,wc,Lt,yc,ya,Ec,$c,kc,V,qt,Cc,Ea,Pc,Dc,$a,xc,Nc,Ie,Ut,Tc,Ot,Sc,ka,Ac,Ic,Mc,T,Gt,jc,Ca,Lc,qc,Pa,Uc,Oc,Da,Gc,Fc,Me,zc,je,Ft,Rc,xa,Hc,Wc,Le,zt,Vc,S,Bc,Na,Kc,Yc,Ta,Zc,Jc,Sa,Qc,Xc,Aa,ed,td,od,qe,Rt,nd,ae,ad,Ia,id,rd,Ma,sd,ld,Ti;return m=new Wt({}),Be=new Wt({}),Xe=new Wt({}),ot=new Wt({}),it=new ie({props:{code:`from diffusers import StableDiffusionControlNetPipeline
from diffusers.utils import load_image

# Let's load the popular vermeer image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

<span class="hljs-comment"># Let&#x27;s load the popular vermeer image</span>
image = load_image(
    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
)`}}),rt=new ie({props:{code:"pip install opencv-contrib-python",highlighted:'pip <span class="hljs-keyword">install</span> opencv-contrib-python'}}),st=new ie({props:{code:"pip install diffusers transformers git+https://github.com/huggingface/accelerate.git",highlighted:'pip install diffusers transformers git+https:<span class="hljs-regexp">//gi</span>thub.com<span class="hljs-regexp">/huggingface/</span>accelerate.git'}}),lt=new ie({props:{code:`import cv2
from PIL import Image
import numpy as np

image = np.array(image)

low_threshold = 100
high_threshold = 200

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)`,highlighted:`<span class="hljs-keyword">import</span> cv2
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

image = np.array(image)

low_threshold = <span class="hljs-number">100</span>
high_threshold = <span class="hljs-number">200</span>

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, <span class="hljs-literal">None</span>]
image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
canny_image = Image.fromarray(image)`}}),ct=new ie({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel
import torch

controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel
<span class="hljs-keyword">import</span> torch

controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
)`}}),dt=new ie({props:{code:`from diffusers import UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

# this command loads the individual model components on GPU on-demand.
pipe.enable_model_cpu_offload()`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

<span class="hljs-comment"># this command loads the individual model components on GPU on-demand.</span>
pipe.enable_model_cpu_offload()`}}),ft=new ie({props:{code:`generator = torch.manual_seed(0)

out_image = pipe(
    "disco dancer with colorful lights", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`generator = torch.manual_seed(<span class="hljs-number">0</span>)

out_image = pipe(
    <span class="hljs-string">&quot;disco dancer with colorful lights&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
).images[<span class="hljs-number">0</span>]`}}),pt=new Wt({}),ht=new Wt({}),Tt=new Wt({}),St=new Y({props:{name:"class diffusers.StableDiffusionControlNetPipeline",anchor:"diffusers.StableDiffusionControlNetPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"controlnet",val:": typing.Union[diffusers.models.controlnet.ControlNetModel, typing.List[diffusers.models.controlnet.ControlNetModel], typing.Tuple[diffusers.models.controlnet.ControlNetModel], diffusers.pipelines.stable_diffusion.pipeline_stable_diffusion_controlnet.MultiControlNetModel]"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionControlNetPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionControlNetPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionControlNetPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.controlnet",description:`<strong>controlnet</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.ControlNetModel">ControlNetModel</a> or <code>List[ControlNetModel]</code>) &#x2014;
Provides additional conditioning to the unet during the denoising process. If you set multiple ControlNets
as a list, the outputs from each ControlNet are added together to create one combined additional
conditioning.`,name:"controlnet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/main/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/main/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionControlNetPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionControlNetPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L149"}}),It=new Y({props:{name:"__call__",anchor:"diffusers.StableDiffusionControlNetPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image, typing.List[torch.FloatTensor], typing.List[PIL.Image.Image]] = None"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"controlnet_conditioning_scale",val:": typing.Union[float, typing.List[float]] = 1.0"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code>, <code>PIL.Image.Image</code>, <code>List[torch.FloatTensor]</code>, <code>List[PIL.Image.Image]</code>, &#x2014;
<code>List[List[torch.FloatTensor]]</code>, or <code>List[List[PIL.Image.Image]]</code>):
The ControlNet input condition. ControlNet uses this input condition to generate guidance to Unet. If
the type is specified as <code>Torch.FloatTensor</code>, it is passed to ControlNet as is. <code>PIL.Image.Image</code> can
also be accepted as an image. The dimensions of the output image defaults to <code>image</code>&#x2019;s dimensions. If
height and/or width are passed, <code>image</code> is resized according to them. If multiple ControlNets are
specified in init, images must be passed as a list such that each element of the list can be correctly
batched for input to a single controlnet.`,name:"image"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code>. instead. If not defined, one has to pass <code>negative_prompt_embeds</code>. instead.
Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.controlnet_conditioning_scale",description:`<strong>controlnet_conditioning_scale</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The outputs of the controlnet are multiplied by <code>controlnet_conditioning_scale</code> before they are added
to the residual in the original unet. If multiple ControlNets are specified in init, you can set the
corresponding scale as a list.`,name:"controlnet_conditioning_scale"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L704",returnDescription:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),Se=new _m({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.example",$$slots:{default:[km]},$$scope:{ctx:Vt}}}),Mt=new Y({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maxium amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/pipeline_utils.py#L1344"}}),jt=new Y({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/pipeline_utils.py#L1360"}}),qt=new Y({props:{name:"enable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L229"}}),Ut=new Y({props:{name:"disable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L239"}}),Gt=new Y({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/pipeline_utils.py#L1287"}}),Me=new _m({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[Cm]},$$scope:{ctx:Vt}}}),Ft=new Y({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/pipeline_utils.py#L1319"}}),zt=new Y({props:{name:"enable_model_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L267"}}),Rt=new Y({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L246"}}),{c(){$=n("meta"),A=c(),k=n("h1"),y=n("a"),N=n("span"),u(m.$$.fragment),D=c(),an=n("span"),sr=s("Text-to-Image Generation with ControlNet Conditioning"),Ra=c(),Z=n("h2"),re=n("a"),rn=n("span"),u(Be.$$.fragment),lr=c(),sn=n("span"),cr=s("Overview"),Ha=c(),Ke=n("p"),Ye=n("a"),dr=s("Adding Conditional Control to Text-to-Image Diffusion Models"),fr=s(" by Lvmin Zhang and Maneesh Agrawala."),Wa=c(),Bt=n("p"),pr=s("Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),Va=c(),Kt=n("p"),mr=s("The abstract of the paper is the following:"),Ba=c(),Yt=n("p"),ln=n("em"),hr=s("We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),Ka=c(),se=n("p"),ur=s("This model was contributed by the amazing community contributor "),Ze=n("a"),gr=s("takuma104"),_r=s(" \u2764\uFE0F ."),Ya=c(),Zt=n("p"),vr=s("Resources:"),Za=c(),le=n("ul"),cn=n("li"),Je=n("a"),br=s("Paper"),wr=c(),dn=n("li"),Qe=n("a"),yr=s("Original Code"),Ja=c(),J=n("h2"),ce=n("a"),fn=n("span"),u(Xe.$$.fragment),Er=c(),pn=n("span"),$r=s("Available Pipelines:"),Qa=c(),de=n("table"),mn=n("thead"),Q=n("tr"),hn=n("th"),kr=s("Pipeline"),Cr=c(),un=n("th"),Pr=s("Tasks"),Dr=c(),Jt=n("th"),xr=s("Demo"),Nr=c(),gn=n("tbody"),X=n("tr"),_n=n("td"),et=n("a"),Tr=s("StableDiffusionControlNetPipeline"),Sr=c(),vn=n("td"),bn=n("em"),Ar=s("Text-to-Image Generation with ControlNet Conditioning"),Ir=c(),Qt=n("td"),tt=n("a"),Mr=s("Colab Example"),Xa=c(),ee=n("h2"),fe=n("a"),wn=n("span"),u(ot.$$.fragment),jr=c(),yn=n("span"),Lr=s("Usage example"),ei=c(),pe=n("p"),qr=s("In the following we give a simple example of how to use a "),En=n("em"),Ur=s("ControlNet"),Or=s(` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),ti=c(),me=n("ul"),$n=n("li"),kn=n("ol"),Cn=n("li"),Gr=s("Take an image and run it through a pre-conditioning processor."),Fr=c(),Pn=n("li"),Xt=n("ol"),nt=n("li"),zr=s("Run the pre-processed image through the "),eo=n("a"),Rr=s("StableDiffusionControlNetPipeline"),Hr=s("."),oi=c(),he=n("p"),Wr=s("Let\u2019s have a look at a simple example using the "),at=n("a"),Vr=s("Canny Edge ControlNet"),Br=s("."),ni=c(),u(it.$$.fragment),ai=c(),to=n("p"),oo=n("img"),ii=c(),z=n("p"),Kr=s("Next, we process the image to get the canny image. This is step "),Dn=n("em"),Yr=s("1."),Zr=s(" - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),no=n("a"),Jr=s("official checkpoints"),Qr=s(" for more information about other models."),ri=c(),ao=n("p"),Xr=s("First, we need to install opencv:"),si=c(),u(rt.$$.fragment),li=c(),io=n("p"),es=s("Next, let\u2019s also install all required Hugging Face libraries:"),ci=c(),u(st.$$.fragment),di=c(),ro=n("p"),ts=s("Then we can retrieve the canny edges of the image."),fi=c(),u(lt.$$.fragment),pi=c(),so=n("p"),os=s("Let\u2019s take a look at the processed image."),mi=c(),lo=n("p"),co=n("img"),hi=c(),ue=n("p"),ns=s("Now, we load the official "),fo=n("a"),as=s("Stable Diffusion 1.5 Model"),is=s(" as well as the ControlNet for canny edges."),ui=c(),u(ct.$$.fragment),gi=c(),ge=n("p"),rs=s("To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),po=n("a"),ss=s("UniPCMultistepScheduler"),ls=s("."),_i=c(),u(dt.$$.fragment),vi=c(),mo=n("p"),cs=s("Finally, we can run the pipeline:"),bi=c(),u(ft.$$.fragment),wi=c(),ho=n("p"),ds=s("This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),yi=c(),uo=n("p"),go=n("img"),Ei=c(),_e=n("p"),xn=n("strong"),fs=s("Note"),ps=s(": To see how to run all other ControlNet checkpoints, please have a look at "),_o=n("a"),ms=s("ControlNet with Stable Diffusion 1.5"),$i=c(),te=n("h2"),ve=n("a"),Nn=n("span"),u(pt.$$.fragment),hs=c(),Tn=n("span"),us=s("Available checkpoints"),ki=c(),R=n("p"),gs=s("ControlNet requires a "),Sn=n("em"),_s=s("control image"),vs=s(" in addition to the text-to-image "),An=n("em"),bs=s("prompt"),ws=s(`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),Ci=c(),be=n("p"),ys=s("All checkpoints can be found under the authors\u2019 namespace "),mt=n("a"),Es=s("lllyasviel"),$s=s("."),Pi=c(),oe=n("h3"),we=n("a"),In=n("span"),u(ht.$$.fragment),ks=c(),Mn=n("span"),Cs=s("ControlNet with Stable Diffusion 1.5"),Di=c(),ye=n("table"),jn=n("thead"),I=n("tr"),Ln=n("th"),Ps=s("Model Name"),Ds=c(),qn=n("th"),xs=s("Control Image Overview"),Ns=c(),Un=n("th"),Ts=s("Control Image Example"),Ss=c(),On=n("th"),As=s("Generated Image Example"),Is=c(),C=n("tbody"),M=n("tr"),Ee=n("td"),ut=n("a"),Ms=s("lllyasviel/sd-controlnet-canny"),js=n("br"),Ls=c(),Gn=n("em"),qs=s("Trained with canny edge detection"),Us=c(),Fn=n("td"),Os=s("A monochrome image with white edges on a black background."),Gs=c(),zn=n("td"),vo=n("a"),$e=n("img"),Fs=c(),Rn=n("td"),bo=n("a"),wo=n("img"),zs=c(),j=n("tr"),ke=n("td"),gt=n("a"),Rs=s("lllyasviel/sd-controlnet-depth"),Hs=n("br"),Ws=c(),Hn=n("em"),Vs=s("Trained with Midas depth estimation"),Bs=c(),Wn=n("td"),Ks=s("A grayscale image with black representing deep areas and white representing shallow areas."),Ys=c(),Vn=n("td"),yo=n("a"),Eo=n("img"),Zs=c(),Bn=n("td"),$o=n("a"),ko=n("img"),Js=c(),L=n("tr"),Ce=n("td"),_t=n("a"),Qs=s("lllyasviel/sd-controlnet-hed"),Xs=n("br"),el=c(),Kn=n("em"),tl=s("Trained with HED edge detection (soft edge)"),ol=c(),Yn=n("td"),nl=s("A monochrome image with white soft edges on a black background."),al=c(),Zn=n("td"),Co=n("a"),Po=n("img"),il=c(),Jn=n("td"),Do=n("a"),xo=n("img"),rl=c(),q=n("tr"),Pe=n("td"),vt=n("a"),sl=s("lllyasviel/sd-controlnet-mlsd"),ll=n("br"),cl=c(),Qn=n("em"),dl=s("Trained with M-LSD line detection"),fl=c(),Xn=n("td"),pl=s("A monochrome image composed only of white straight lines on a black background."),ml=c(),ea=n("td"),No=n("a"),To=n("img"),hl=c(),ta=n("td"),So=n("a"),Ao=n("img"),ul=c(),U=n("tr"),De=n("td"),bt=n("a"),gl=s("lllyasviel/sd-controlnet-normal"),_l=n("br"),vl=c(),oa=n("em"),bl=s("Trained with normal map"),wl=c(),wt=n("td"),yl=s("A "),yt=n("a"),El=s("normal mapped"),$l=s(" image."),kl=c(),na=n("td"),Io=n("a"),Mo=n("img"),Cl=c(),aa=n("td"),jo=n("a"),Lo=n("img"),Pl=c(),O=n("tr"),xe=n("td"),Et=n("a"),Dl=s("lllyasviel/sd-controlnet-openpose"),xl=n("br"),Nl=c(),ia=n("em"),Tl=s("Trained with OpenPose bone image"),Sl=c(),$t=n("td"),Al=s("A "),kt=n("a"),Il=s("OpenPose bone"),Ml=s(" image."),jl=c(),ra=n("td"),qo=n("a"),Uo=n("img"),Ll=c(),sa=n("td"),Oo=n("a"),Go=n("img"),ql=c(),G=n("tr"),Ne=n("td"),Ct=n("a"),Ul=s("lllyasviel/sd-controlnet-scribble"),Ol=n("br"),Gl=c(),la=n("em"),Fl=s("Trained with human scribbles"),zl=c(),ca=n("td"),Rl=s("A hand-drawn monochrome image with white outlines on a black background."),Hl=c(),da=n("td"),Fo=n("a"),zo=n("img"),Wl=c(),fa=n("td"),Ro=n("a"),Ho=n("img"),Vl=c(),F=n("tr"),Pt=n("td"),Dt=n("a"),Bl=s("lllyasviel/sd-controlnet-seg"),Kl=n("br"),pa=n("em"),Yl=s("Trained with semantic segmentation"),Zl=c(),xt=n("td"),Jl=s("An "),Nt=n("a"),Ql=s("ADE20K"),Xl=s("\u2019s segmentation protocol image."),ec=c(),ma=n("td"),Wo=n("a"),Vo=n("img"),tc=c(),ha=n("td"),Bo=n("a"),Ko=n("img"),xi=c(),ne=n("h2"),Te=n("a"),ua=n("span"),u(Tt.$$.fragment),oc=c(),ga=n("span"),nc=s("StableDiffusionControlNetPipeline"),Ni=c(),h=n("div"),u(St.$$.fragment),ac=c(),_a=n("p"),ic=s("Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),rc=c(),At=n("p"),sc=s("This model inherits from "),Yo=n("a"),lc=s("DiffusionPipeline"),cc=s(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),dc=c(),H=n("div"),u(It.$$.fragment),fc=c(),va=n("p"),pc=s("Function invoked when calling the pipeline for generation."),mc=c(),u(Se.$$.fragment),hc=c(),W=n("div"),u(Mt.$$.fragment),uc=c(),ba=n("p"),gc=s("Enable sliced attention computation."),_c=c(),wa=n("p"),vc=s(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),bc=c(),Ae=n("div"),u(jt.$$.fragment),wc=c(),Lt=n("p"),yc=s("Disable sliced attention computation. If "),ya=n("code"),Ec=s("enable_attention_slicing"),$c=s(` was previously invoked, this method will go
back to computing attention in one step.`),kc=c(),V=n("div"),u(qt.$$.fragment),Cc=c(),Ea=n("p"),Pc=s("Enable sliced VAE decoding."),Dc=c(),$a=n("p"),xc=s(`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),Nc=c(),Ie=n("div"),u(Ut.$$.fragment),Tc=c(),Ot=n("p"),Sc=s("Disable sliced VAE decoding. If "),ka=n("code"),Ac=s("enable_vae_slicing"),Ic=s(` was previously invoked, this method will go back to
computing decoding in one step.`),Mc=c(),T=n("div"),u(Gt.$$.fragment),jc=c(),Ca=n("p"),Lc=s("Enable memory efficient attention as implemented in xformers."),qc=c(),Pa=n("p"),Uc=s(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Oc=c(),Da=n("p"),Gc=s(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Fc=c(),u(Me.$$.fragment),zc=c(),je=n("div"),u(Ft.$$.fragment),Rc=c(),xa=n("p"),Hc=s("Disable memory efficient attention as implemented in xformers."),Wc=c(),Le=n("div"),u(zt.$$.fragment),Vc=c(),S=n("p"),Bc=s(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Na=n("code"),Kc=s("enable_sequential_cpu_offload"),Yc=s(", this method moves one whole model at a time to the GPU when its "),Ta=n("code"),Zc=s("forward"),Jc=s(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Sa=n("code"),Qc=s("enable_sequential_cpu_offload"),Xc=s(", but performance is much better due to the iterative execution of the "),Aa=n("code"),ed=s("unet"),td=s("."),od=c(),qe=n("div"),u(Rt.$$.fragment),nd=c(),ae=n("p"),ad=s(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),Ia=n("code"),id=s("torch.device('meta') and loaded to GPU only when their specific submodule has its "),rd=s("forward"),Ma=n("code"),sd=s("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),ld=s("enable_model_cpu_offload`, but performance is lower."),this.h()},l(t){const f=Em('[data-svelte="svelte-1phssyn"]',document.head);$=a(f,"META",{name:!0,content:!0}),f.forEach(o),A=d(t),k=a(t,"H1",{class:!0});var Ht=i(k);y=a(Ht,"A",{id:!0,class:!0,href:!0});var ja=i(y);N=a(ja,"SPAN",{});var Nd=i(N);g(m.$$.fragment,Nd),Nd.forEach(o),ja.forEach(o),D=d(Ht),an=a(Ht,"SPAN",{});var Td=i(an);sr=l(Td,"Text-to-Image Generation with ControlNet Conditioning"),Td.forEach(o),Ht.forEach(o),Ra=d(t),Z=a(t,"H2",{class:!0});var Si=i(Z);re=a(Si,"A",{id:!0,class:!0,href:!0});var Sd=i(re);rn=a(Sd,"SPAN",{});var Ad=i(rn);g(Be.$$.fragment,Ad),Ad.forEach(o),Sd.forEach(o),lr=d(Si),sn=a(Si,"SPAN",{});var Id=i(sn);cr=l(Id,"Overview"),Id.forEach(o),Si.forEach(o),Ha=d(t),Ke=a(t,"P",{});var cd=i(Ke);Ye=a(cd,"A",{href:!0,rel:!0});var Md=i(Ye);dr=l(Md,"Adding Conditional Control to Text-to-Image Diffusion Models"),Md.forEach(o),fr=l(cd," by Lvmin Zhang and Maneesh Agrawala."),cd.forEach(o),Wa=d(t),Bt=a(t,"P",{});var jd=i(Bt);pr=l(jd,"Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),jd.forEach(o),Va=d(t),Kt=a(t,"P",{});var Ld=i(Kt);mr=l(Ld,"The abstract of the paper is the following:"),Ld.forEach(o),Ba=d(t),Yt=a(t,"P",{});var qd=i(Yt);ln=a(qd,"EM",{});var Ud=i(ln);hr=l(Ud,"We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),Ud.forEach(o),qd.forEach(o),Ka=d(t),se=a(t,"P",{});var Ai=i(se);ur=l(Ai,"This model was contributed by the amazing community contributor "),Ze=a(Ai,"A",{href:!0,rel:!0});var Od=i(Ze);gr=l(Od,"takuma104"),Od.forEach(o),_r=l(Ai," \u2764\uFE0F ."),Ai.forEach(o),Ya=d(t),Zt=a(t,"P",{});var Gd=i(Zt);vr=l(Gd,"Resources:"),Gd.forEach(o),Za=d(t),le=a(t,"UL",{});var Ii=i(le);cn=a(Ii,"LI",{});var Fd=i(cn);Je=a(Fd,"A",{href:!0,rel:!0});var zd=i(Je);br=l(zd,"Paper"),zd.forEach(o),Fd.forEach(o),wr=d(Ii),dn=a(Ii,"LI",{});var Rd=i(dn);Qe=a(Rd,"A",{href:!0,rel:!0});var Hd=i(Qe);yr=l(Hd,"Original Code"),Hd.forEach(o),Rd.forEach(o),Ii.forEach(o),Ja=d(t),J=a(t,"H2",{class:!0});var Mi=i(J);ce=a(Mi,"A",{id:!0,class:!0,href:!0});var Wd=i(ce);fn=a(Wd,"SPAN",{});var Vd=i(fn);g(Xe.$$.fragment,Vd),Vd.forEach(o),Wd.forEach(o),Er=d(Mi),pn=a(Mi,"SPAN",{});var Bd=i(pn);$r=l(Bd,"Available Pipelines:"),Bd.forEach(o),Mi.forEach(o),Qa=d(t),de=a(t,"TABLE",{});var ji=i(de);mn=a(ji,"THEAD",{});var Kd=i(mn);Q=a(Kd,"TR",{});var Zo=i(Q);hn=a(Zo,"TH",{});var Yd=i(hn);kr=l(Yd,"Pipeline"),Yd.forEach(o),Cr=d(Zo),un=a(Zo,"TH",{});var Zd=i(un);Pr=l(Zd,"Tasks"),Zd.forEach(o),Dr=d(Zo),Jt=a(Zo,"TH",{align:!0});var Jd=i(Jt);xr=l(Jd,"Demo"),Jd.forEach(o),Zo.forEach(o),Kd.forEach(o),Nr=d(ji),gn=a(ji,"TBODY",{});var Qd=i(gn);X=a(Qd,"TR",{});var Jo=i(X);_n=a(Jo,"TD",{});var Xd=i(_n);et=a(Xd,"A",{href:!0,rel:!0});var ef=i(et);Tr=l(ef,"StableDiffusionControlNetPipeline"),ef.forEach(o),Xd.forEach(o),Sr=d(Jo),vn=a(Jo,"TD",{});var tf=i(vn);bn=a(tf,"EM",{});var of=i(bn);Ar=l(of,"Text-to-Image Generation with ControlNet Conditioning"),of.forEach(o),tf.forEach(o),Ir=d(Jo),Qt=a(Jo,"TD",{align:!0});var nf=i(Qt);tt=a(nf,"A",{href:!0,rel:!0});var af=i(tt);Mr=l(af,"Colab Example"),af.forEach(o),nf.forEach(o),Jo.forEach(o),Qd.forEach(o),ji.forEach(o),Xa=d(t),ee=a(t,"H2",{class:!0});var Li=i(ee);fe=a(Li,"A",{id:!0,class:!0,href:!0});var rf=i(fe);wn=a(rf,"SPAN",{});var sf=i(wn);g(ot.$$.fragment,sf),sf.forEach(o),rf.forEach(o),jr=d(Li),yn=a(Li,"SPAN",{});var lf=i(yn);Lr=l(lf,"Usage example"),lf.forEach(o),Li.forEach(o),ei=d(t),pe=a(t,"P",{});var qi=i(pe);qr=l(qi,"In the following we give a simple example of how to use a "),En=a(qi,"EM",{});var cf=i(En);Ur=l(cf,"ControlNet"),cf.forEach(o),Or=l(qi,` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),qi.forEach(o),ti=d(t),me=a(t,"UL",{});var Ui=i(me);$n=a(Ui,"LI",{});var df=i($n);kn=a(df,"OL",{});var ff=i(kn);Cn=a(ff,"LI",{});var pf=i(Cn);Gr=l(pf,"Take an image and run it through a pre-conditioning processor."),pf.forEach(o),ff.forEach(o),df.forEach(o),Fr=d(Ui),Pn=a(Ui,"LI",{});var mf=i(Pn);Xt=a(mf,"OL",{start:!0});var hf=i(Xt);nt=a(hf,"LI",{});var Oi=i(nt);zr=l(Oi,"Run the pre-processed image through the "),eo=a(Oi,"A",{href:!0});var uf=i(eo);Rr=l(uf,"StableDiffusionControlNetPipeline"),uf.forEach(o),Hr=l(Oi,"."),Oi.forEach(o),hf.forEach(o),mf.forEach(o),Ui.forEach(o),oi=d(t),he=a(t,"P",{});var Gi=i(he);Wr=l(Gi,"Let\u2019s have a look at a simple example using the "),at=a(Gi,"A",{href:!0,rel:!0});var gf=i(at);Vr=l(gf,"Canny Edge ControlNet"),gf.forEach(o),Br=l(Gi,"."),Gi.forEach(o),ni=d(t),g(it.$$.fragment,t),ai=d(t),to=a(t,"P",{});var _f=i(to);oo=a(_f,"IMG",{src:!0,alt:!0}),_f.forEach(o),ii=d(t),z=a(t,"P",{});var Qo=i(z);Kr=l(Qo,"Next, we process the image to get the canny image. This is step "),Dn=a(Qo,"EM",{});var vf=i(Dn);Yr=l(vf,"1."),vf.forEach(o),Zr=l(Qo," - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),no=a(Qo,"A",{href:!0});var bf=i(no);Jr=l(bf,"official checkpoints"),bf.forEach(o),Qr=l(Qo," for more information about other models."),Qo.forEach(o),ri=d(t),ao=a(t,"P",{});var wf=i(ao);Xr=l(wf,"First, we need to install opencv:"),wf.forEach(o),si=d(t),g(rt.$$.fragment,t),li=d(t),io=a(t,"P",{});var yf=i(io);es=l(yf,"Next, let\u2019s also install all required Hugging Face libraries:"),yf.forEach(o),ci=d(t),g(st.$$.fragment,t),di=d(t),ro=a(t,"P",{});var Ef=i(ro);ts=l(Ef,"Then we can retrieve the canny edges of the image."),Ef.forEach(o),fi=d(t),g(lt.$$.fragment,t),pi=d(t),so=a(t,"P",{});var $f=i(so);os=l($f,"Let\u2019s take a look at the processed image."),$f.forEach(o),mi=d(t),lo=a(t,"P",{});var kf=i(lo);co=a(kf,"IMG",{src:!0,alt:!0}),kf.forEach(o),hi=d(t),ue=a(t,"P",{});var Fi=i(ue);ns=l(Fi,"Now, we load the official "),fo=a(Fi,"A",{href:!0});var Cf=i(fo);as=l(Cf,"Stable Diffusion 1.5 Model"),Cf.forEach(o),is=l(Fi," as well as the ControlNet for canny edges."),Fi.forEach(o),ui=d(t),g(ct.$$.fragment,t),gi=d(t),ge=a(t,"P",{});var zi=i(ge);rs=l(zi,"To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),po=a(zi,"A",{href:!0});var Pf=i(po);ss=l(Pf,"UniPCMultistepScheduler"),Pf.forEach(o),ls=l(zi,"."),zi.forEach(o),_i=d(t),g(dt.$$.fragment,t),vi=d(t),mo=a(t,"P",{});var Df=i(mo);cs=l(Df,"Finally, we can run the pipeline:"),Df.forEach(o),bi=d(t),g(ft.$$.fragment,t),wi=d(t),ho=a(t,"P",{});var xf=i(ho);ds=l(xf,"This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),xf.forEach(o),yi=d(t),uo=a(t,"P",{});var Nf=i(uo);go=a(Nf,"IMG",{src:!0,alt:!0}),Nf.forEach(o),Ei=d(t),_e=a(t,"P",{});var Ri=i(_e);xn=a(Ri,"STRONG",{});var Tf=i(xn);fs=l(Tf,"Note"),Tf.forEach(o),ps=l(Ri,": To see how to run all other ControlNet checkpoints, please have a look at "),_o=a(Ri,"A",{href:!0});var Sf=i(_o);ms=l(Sf,"ControlNet with Stable Diffusion 1.5"),Sf.forEach(o),Ri.forEach(o),$i=d(t),te=a(t,"H2",{class:!0});var Hi=i(te);ve=a(Hi,"A",{id:!0,class:!0,href:!0});var Af=i(ve);Nn=a(Af,"SPAN",{});var If=i(Nn);g(pt.$$.fragment,If),If.forEach(o),Af.forEach(o),hs=d(Hi),Tn=a(Hi,"SPAN",{});var Mf=i(Tn);us=l(Mf,"Available checkpoints"),Mf.forEach(o),Hi.forEach(o),ki=d(t),R=a(t,"P",{});var Xo=i(R);gs=l(Xo,"ControlNet requires a "),Sn=a(Xo,"EM",{});var jf=i(Sn);_s=l(jf,"control image"),jf.forEach(o),vs=l(Xo," in addition to the text-to-image "),An=a(Xo,"EM",{});var Lf=i(An);bs=l(Lf,"prompt"),Lf.forEach(o),ws=l(Xo,`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),Xo.forEach(o),Ci=d(t),be=a(t,"P",{});var Wi=i(be);ys=l(Wi,"All checkpoints can be found under the authors\u2019 namespace "),mt=a(Wi,"A",{href:!0,rel:!0});var qf=i(mt);Es=l(qf,"lllyasviel"),qf.forEach(o),$s=l(Wi,"."),Wi.forEach(o),Pi=d(t),oe=a(t,"H3",{class:!0});var Vi=i(oe);we=a(Vi,"A",{id:!0,class:!0,href:!0});var Uf=i(we);In=a(Uf,"SPAN",{});var Of=i(In);g(ht.$$.fragment,Of),Of.forEach(o),Uf.forEach(o),ks=d(Vi),Mn=a(Vi,"SPAN",{});var Gf=i(Mn);Cs=l(Gf,"ControlNet with Stable Diffusion 1.5"),Gf.forEach(o),Vi.forEach(o),Di=d(t),ye=a(t,"TABLE",{});var Bi=i(ye);jn=a(Bi,"THEAD",{});var Ff=i(jn);I=a(Ff,"TR",{});var Ue=i(I);Ln=a(Ue,"TH",{});var zf=i(Ln);Ps=l(zf,"Model Name"),zf.forEach(o),Ds=d(Ue),qn=a(Ue,"TH",{});var Rf=i(qn);xs=l(Rf,"Control Image Overview"),Rf.forEach(o),Ns=d(Ue),Un=a(Ue,"TH",{});var Hf=i(Un);Ts=l(Hf,"Control Image Example"),Hf.forEach(o),Ss=d(Ue),On=a(Ue,"TH",{});var Wf=i(On);As=l(Wf,"Generated Image Example"),Wf.forEach(o),Ue.forEach(o),Ff.forEach(o),Is=d(Bi),C=a(Bi,"TBODY",{});var x=i(C);M=a(x,"TR",{});var Oe=i(M);Ee=a(Oe,"TD",{});var La=i(Ee);ut=a(La,"A",{href:!0,rel:!0});var Vf=i(ut);Ms=l(Vf,"lllyasviel/sd-controlnet-canny"),Vf.forEach(o),js=a(La,"BR",{}),Ls=d(La),Gn=a(La,"EM",{});var Bf=i(Gn);qs=l(Bf,"Trained with canny edge detection"),Bf.forEach(o),La.forEach(o),Us=d(Oe),Fn=a(Oe,"TD",{});var Kf=i(Fn);Os=l(Kf,"A monochrome image with white edges on a black background."),Kf.forEach(o),Gs=d(Oe),zn=a(Oe,"TD",{});var Yf=i(zn);vo=a(Yf,"A",{href:!0});var Zf=i(vo);$e=a(Zf,"IMG",{width:!0,style:!0,src:!0}),Zf.forEach(o),Yf.forEach(o),Fs=d(Oe),Rn=a(Oe,"TD",{});var Jf=i(Rn);bo=a(Jf,"A",{href:!0});var Qf=i(bo);wo=a(Qf,"IMG",{width:!0,src:!0}),Qf.forEach(o),Jf.forEach(o),Oe.forEach(o),zs=d(x),j=a(x,"TR",{});var Ge=i(j);ke=a(Ge,"TD",{});var qa=i(ke);gt=a(qa,"A",{href:!0,rel:!0});var Xf=i(gt);Rs=l(Xf,"lllyasviel/sd-controlnet-depth"),Xf.forEach(o),Hs=a(qa,"BR",{}),Ws=d(qa),Hn=a(qa,"EM",{});var ep=i(Hn);Vs=l(ep,"Trained with Midas depth estimation"),ep.forEach(o),qa.forEach(o),Bs=d(Ge),Wn=a(Ge,"TD",{});var tp=i(Wn);Ks=l(tp,"A grayscale image with black representing deep areas and white representing shallow areas."),tp.forEach(o),Ys=d(Ge),Vn=a(Ge,"TD",{});var op=i(Vn);yo=a(op,"A",{href:!0});var np=i(yo);Eo=a(np,"IMG",{width:!0,src:!0}),np.forEach(o),op.forEach(o),Zs=d(Ge),Bn=a(Ge,"TD",{});var ap=i(Bn);$o=a(ap,"A",{href:!0});var ip=i($o);ko=a(ip,"IMG",{width:!0,src:!0}),ip.forEach(o),ap.forEach(o),Ge.forEach(o),Js=d(x),L=a(x,"TR",{});var Fe=i(L);Ce=a(Fe,"TD",{});var Ua=i(Ce);_t=a(Ua,"A",{href:!0,rel:!0});var rp=i(_t);Qs=l(rp,"lllyasviel/sd-controlnet-hed"),rp.forEach(o),Xs=a(Ua,"BR",{}),el=d(Ua),Kn=a(Ua,"EM",{});var sp=i(Kn);tl=l(sp,"Trained with HED edge detection (soft edge)"),sp.forEach(o),Ua.forEach(o),ol=d(Fe),Yn=a(Fe,"TD",{});var lp=i(Yn);nl=l(lp,"A monochrome image with white soft edges on a black background."),lp.forEach(o),al=d(Fe),Zn=a(Fe,"TD",{});var cp=i(Zn);Co=a(cp,"A",{href:!0});var dp=i(Co);Po=a(dp,"IMG",{width:!0,src:!0}),dp.forEach(o),cp.forEach(o),il=d(Fe),Jn=a(Fe,"TD",{});var fp=i(Jn);Do=a(fp,"A",{href:!0});var pp=i(Do);xo=a(pp,"IMG",{width:!0,src:!0}),pp.forEach(o),fp.forEach(o),Fe.forEach(o),rl=d(x),q=a(x,"TR",{});var ze=i(q);Pe=a(ze,"TD",{});var Oa=i(Pe);vt=a(Oa,"A",{href:!0,rel:!0});var mp=i(vt);sl=l(mp,"lllyasviel/sd-controlnet-mlsd"),mp.forEach(o),ll=a(Oa,"BR",{}),cl=d(Oa),Qn=a(Oa,"EM",{});var hp=i(Qn);dl=l(hp,"Trained with M-LSD line detection"),hp.forEach(o),Oa.forEach(o),fl=d(ze),Xn=a(ze,"TD",{});var up=i(Xn);pl=l(up,"A monochrome image composed only of white straight lines on a black background."),up.forEach(o),ml=d(ze),ea=a(ze,"TD",{});var gp=i(ea);No=a(gp,"A",{href:!0});var _p=i(No);To=a(_p,"IMG",{width:!0,src:!0}),_p.forEach(o),gp.forEach(o),hl=d(ze),ta=a(ze,"TD",{});var vp=i(ta);So=a(vp,"A",{href:!0});var bp=i(So);Ao=a(bp,"IMG",{width:!0,src:!0}),bp.forEach(o),vp.forEach(o),ze.forEach(o),ul=d(x),U=a(x,"TR",{});var Re=i(U);De=a(Re,"TD",{});var Ga=i(De);bt=a(Ga,"A",{href:!0,rel:!0});var wp=i(bt);gl=l(wp,"lllyasviel/sd-controlnet-normal"),wp.forEach(o),_l=a(Ga,"BR",{}),vl=d(Ga),oa=a(Ga,"EM",{});var yp=i(oa);bl=l(yp,"Trained with normal map"),yp.forEach(o),Ga.forEach(o),wl=d(Re),wt=a(Re,"TD",{});var Ki=i(wt);yl=l(Ki,"A "),yt=a(Ki,"A",{href:!0,rel:!0});var Ep=i(yt);El=l(Ep,"normal mapped"),Ep.forEach(o),$l=l(Ki," image."),Ki.forEach(o),kl=d(Re),na=a(Re,"TD",{});var $p=i(na);Io=a($p,"A",{href:!0});var kp=i(Io);Mo=a(kp,"IMG",{width:!0,src:!0}),kp.forEach(o),$p.forEach(o),Cl=d(Re),aa=a(Re,"TD",{});var Cp=i(aa);jo=a(Cp,"A",{href:!0});var Pp=i(jo);Lo=a(Pp,"IMG",{width:!0,src:!0}),Pp.forEach(o),Cp.forEach(o),Re.forEach(o),Pl=d(x),O=a(x,"TR",{});var He=i(O);xe=a(He,"TD",{});var Fa=i(xe);Et=a(Fa,"A",{href:!0,rel:!0});var Dp=i(Et);Dl=l(Dp,"lllyasviel/sd-controlnet-openpose"),Dp.forEach(o),xl=a(Fa,"BR",{}),Nl=d(Fa),ia=a(Fa,"EM",{});var xp=i(ia);Tl=l(xp,"Trained with OpenPose bone image"),xp.forEach(o),Fa.forEach(o),Sl=d(He),$t=a(He,"TD",{});var Yi=i($t);Al=l(Yi,"A "),kt=a(Yi,"A",{href:!0,rel:!0});var Np=i(kt);Il=l(Np,"OpenPose bone"),Np.forEach(o),Ml=l(Yi," image."),Yi.forEach(o),jl=d(He),ra=a(He,"TD",{});var Tp=i(ra);qo=a(Tp,"A",{href:!0});var Sp=i(qo);Uo=a(Sp,"IMG",{width:!0,src:!0}),Sp.forEach(o),Tp.forEach(o),Ll=d(He),sa=a(He,"TD",{});var Ap=i(sa);Oo=a(Ap,"A",{href:!0});var Ip=i(Oo);Go=a(Ip,"IMG",{width:!0,src:!0}),Ip.forEach(o),Ap.forEach(o),He.forEach(o),ql=d(x),G=a(x,"TR",{});var We=i(G);Ne=a(We,"TD",{});var za=i(Ne);Ct=a(za,"A",{href:!0,rel:!0});var Mp=i(Ct);Ul=l(Mp,"lllyasviel/sd-controlnet-scribble"),Mp.forEach(o),Ol=a(za,"BR",{}),Gl=d(za),la=a(za,"EM",{});var jp=i(la);Fl=l(jp,"Trained with human scribbles"),jp.forEach(o),za.forEach(o),zl=d(We),ca=a(We,"TD",{});var Lp=i(ca);Rl=l(Lp,"A hand-drawn monochrome image with white outlines on a black background."),Lp.forEach(o),Hl=d(We),da=a(We,"TD",{});var qp=i(da);Fo=a(qp,"A",{href:!0});var Up=i(Fo);zo=a(Up,"IMG",{width:!0,src:!0}),Up.forEach(o),qp.forEach(o),Wl=d(We),fa=a(We,"TD",{});var Op=i(fa);Ro=a(Op,"A",{href:!0});var Gp=i(Ro);Ho=a(Gp,"IMG",{width:!0,src:!0}),Gp.forEach(o),Op.forEach(o),We.forEach(o),Vl=d(x),F=a(x,"TR",{});var Ve=i(F);Pt=a(Ve,"TD",{});var Zi=i(Pt);Dt=a(Zi,"A",{href:!0,rel:!0});var Fp=i(Dt);Bl=l(Fp,"lllyasviel/sd-controlnet-seg"),Fp.forEach(o),Kl=a(Zi,"BR",{}),pa=a(Zi,"EM",{});var zp=i(pa);Yl=l(zp,"Trained with semantic segmentation"),zp.forEach(o),Zi.forEach(o),Zl=d(Ve),xt=a(Ve,"TD",{});var Ji=i(xt);Jl=l(Ji,"An "),Nt=a(Ji,"A",{href:!0,rel:!0});var Rp=i(Nt);Ql=l(Rp,"ADE20K"),Rp.forEach(o),Xl=l(Ji,"\u2019s segmentation protocol image."),Ji.forEach(o),ec=d(Ve),ma=a(Ve,"TD",{});var Hp=i(ma);Wo=a(Hp,"A",{href:!0});var Wp=i(Wo);Vo=a(Wp,"IMG",{width:!0,src:!0}),Wp.forEach(o),Hp.forEach(o),tc=d(Ve),ha=a(Ve,"TD",{});var Vp=i(ha);Bo=a(Vp,"A",{href:!0});var Bp=i(Bo);Ko=a(Bp,"IMG",{width:!0,src:!0}),Bp.forEach(o),Vp.forEach(o),Ve.forEach(o),x.forEach(o),Bi.forEach(o),xi=d(t),ne=a(t,"H2",{class:!0});var Qi=i(ne);Te=a(Qi,"A",{id:!0,class:!0,href:!0});var Kp=i(Te);ua=a(Kp,"SPAN",{});var Yp=i(ua);g(Tt.$$.fragment,Yp),Yp.forEach(o),Kp.forEach(o),oc=d(Qi),ga=a(Qi,"SPAN",{});var Zp=i(ga);nc=l(Zp,"StableDiffusionControlNetPipeline"),Zp.forEach(o),Qi.forEach(o),Ni=d(t),h=a(t,"DIV",{class:!0});var E=i(h);g(St.$$.fragment,E),ac=d(E),_a=a(E,"P",{});var Jp=i(_a);ic=l(Jp,"Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),Jp.forEach(o),rc=d(E),At=a(E,"P",{});var Xi=i(At);sc=l(Xi,"This model inherits from "),Yo=a(Xi,"A",{href:!0});var Qp=i(Yo);lc=l(Qp,"DiffusionPipeline"),Qp.forEach(o),cc=l(Xi,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Xi.forEach(o),dc=d(E),H=a(E,"DIV",{class:!0});var en=i(H);g(It.$$.fragment,en),fc=d(en),va=a(en,"P",{});var Xp=i(va);pc=l(Xp,"Function invoked when calling the pipeline for generation."),Xp.forEach(o),mc=d(en),g(Se.$$.fragment,en),en.forEach(o),hc=d(E),W=a(E,"DIV",{class:!0});var tn=i(W);g(Mt.$$.fragment,tn),uc=d(tn),ba=a(tn,"P",{});var em=i(ba);gc=l(em,"Enable sliced attention computation."),em.forEach(o),_c=d(tn),wa=a(tn,"P",{});var tm=i(wa);vc=l(tm,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),tm.forEach(o),tn.forEach(o),bc=d(E),Ae=a(E,"DIV",{class:!0});var er=i(Ae);g(jt.$$.fragment,er),wc=d(er),Lt=a(er,"P",{});var tr=i(Lt);yc=l(tr,"Disable sliced attention computation. If "),ya=a(tr,"CODE",{});var om=i(ya);Ec=l(om,"enable_attention_slicing"),om.forEach(o),$c=l(tr,` was previously invoked, this method will go
back to computing attention in one step.`),tr.forEach(o),er.forEach(o),kc=d(E),V=a(E,"DIV",{class:!0});var on=i(V);g(qt.$$.fragment,on),Cc=d(on),Ea=a(on,"P",{});var nm=i(Ea);Pc=l(nm,"Enable sliced VAE decoding."),nm.forEach(o),Dc=d(on),$a=a(on,"P",{});var am=i($a);xc=l(am,`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),am.forEach(o),on.forEach(o),Nc=d(E),Ie=a(E,"DIV",{class:!0});var or=i(Ie);g(Ut.$$.fragment,or),Tc=d(or),Ot=a(or,"P",{});var nr=i(Ot);Sc=l(nr,"Disable sliced VAE decoding. If "),ka=a(nr,"CODE",{});var im=i(ka);Ac=l(im,"enable_vae_slicing"),im.forEach(o),Ic=l(nr,` was previously invoked, this method will go back to
computing decoding in one step.`),nr.forEach(o),or.forEach(o),Mc=d(E),T=a(E,"DIV",{class:!0});var B=i(T);g(Gt.$$.fragment,B),jc=d(B),Ca=a(B,"P",{});var rm=i(Ca);Lc=l(rm,"Enable memory efficient attention as implemented in xformers."),rm.forEach(o),qc=d(B),Pa=a(B,"P",{});var sm=i(Pa);Uc=l(sm,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),sm.forEach(o),Oc=d(B),Da=a(B,"P",{});var lm=i(Da);Gc=l(lm,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),lm.forEach(o),Fc=d(B),g(Me.$$.fragment,B),B.forEach(o),zc=d(E),je=a(E,"DIV",{class:!0});var ar=i(je);g(Ft.$$.fragment,ar),Rc=d(ar),xa=a(ar,"P",{});var cm=i(xa);Hc=l(cm,"Disable memory efficient attention as implemented in xformers."),cm.forEach(o),ar.forEach(o),Wc=d(E),Le=a(E,"DIV",{class:!0});var ir=i(Le);g(zt.$$.fragment,ir),Vc=d(ir),S=a(ir,"P",{});var K=i(S);Bc=l(K,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),Na=a(K,"CODE",{});var dm=i(Na);Kc=l(dm,"enable_sequential_cpu_offload"),dm.forEach(o),Yc=l(K,", this method moves one whole model at a time to the GPU when its "),Ta=a(K,"CODE",{});var fm=i(Ta);Zc=l(fm,"forward"),fm.forEach(o),Jc=l(K,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Sa=a(K,"CODE",{});var pm=i(Sa);Qc=l(pm,"enable_sequential_cpu_offload"),pm.forEach(o),Xc=l(K,", but performance is much better due to the iterative execution of the "),Aa=a(K,"CODE",{});var mm=i(Aa);ed=l(mm,"unet"),mm.forEach(o),td=l(K,"."),K.forEach(o),ir.forEach(o),od=d(E),qe=a(E,"DIV",{class:!0});var rr=i(qe);g(Rt.$$.fragment,rr),nd=d(rr),ae=a(rr,"P",{});var nn=i(ae);ad=l(nn,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),Ia=a(nn,"CODE",{});var hm=i(Ia);id=l(hm,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),hm.forEach(o),rd=l(nn,"forward"),Ma=a(nn,"CODE",{});var um=i(Ma);sd=l(um,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),um.forEach(o),ld=l(nn,"enable_model_cpu_offload`, but performance is lower."),nn.forEach(o),rr.forEach(o),E.forEach(o),this.h()},h(){r($,"name","hf:doc:metadata"),r($,"content",JSON.stringify(Dm)),r(y,"id","texttoimage-generation-with-controlnet-conditioning"),r(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(y,"href","#texttoimage-generation-with-controlnet-conditioning"),r(k,"class","relative group"),r(re,"id","overview"),r(re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(re,"href","#overview"),r(Z,"class","relative group"),r(Ye,"href","https://arxiv.org/abs/2302.05543"),r(Ye,"rel","nofollow"),r(Ze,"href","https://huggingface.co/takuma104"),r(Ze,"rel","nofollow"),r(Je,"href","https://arxiv.org/abs/2302.05543"),r(Je,"rel","nofollow"),r(Qe,"href","https://github.com/lllyasviel/ControlNet"),r(Qe,"rel","nofollow"),r(ce,"id","available-pipelines"),r(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(ce,"href","#available-pipelines"),r(J,"class","relative group"),r(Jt,"align","center"),r(et,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py"),r(et,"rel","nofollow"),r(tt,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers/controlnet.ipynb"),r(tt,"rel","nofollow"),r(Qt,"align","center"),r(fe,"id","usage-example"),r(fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(fe,"href","#usage-example"),r(ee,"class","relative group"),r(eo,"href","/docs/diffusers/main/en/api/pipelines/stable_diffusion/controlnet#diffusers.StableDiffusionControlNetPipeline"),r(Xt,"start","2"),r(at,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),r(at,"rel","nofollow"),P(oo.src,dd="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png")||r(oo,"src",dd),r(oo,"alt","img"),r(no,"href","#controlnet-with-stable-diffusion-1.5"),P(co.src,fd="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_canny_edged.png")||r(co,"src",fd),r(co,"alt","img"),r(fo,"href","runwayml/stable-diffusion-v1-5"),r(po,"href","/docs/diffusers/main/en/api/schedulers/unipc#diffusers.UniPCMultistepScheduler"),P(go.src,pd="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_disco_dancing.png")||r(go,"src",pd),r(go,"alt","img"),r(_o,"href","#controlnet-with-stable-diffusion-1.5"),r(ve,"id","available-checkpoints"),r(ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(ve,"href","#available-checkpoints"),r(te,"class","relative group"),r(mt,"href","https://huggingface.co/lllyasviel"),r(mt,"rel","nofollow"),r(we,"id","controlnet-with-stable-diffusion-15"),r(we,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(we,"href","#controlnet-with-stable-diffusion-15"),r(oe,"class","relative group"),r(ut,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),r(ut,"rel","nofollow"),r($e,"width","64"),gm($e,"margin","0"),gm($e,"padding","0"),P($e.src,md="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_canny.png")||r($e,"src",md),r(vo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_canny.png"),r(wo,"width","64"),P(wo.src,hd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png")||r(wo,"src",hd),r(bo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png"),r(gt,"href","https://huggingface.co/lllyasviel/sd-controlnet-depth"),r(gt,"rel","nofollow"),r(Eo,"width","64"),P(Eo.src,ud="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_depth.png")||r(Eo,"src",ud),r(yo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_depth.png"),r(ko,"width","64"),P(ko.src,gd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png")||r(ko,"src",gd),r($o,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png"),r(_t,"href","https://huggingface.co/lllyasviel/sd-controlnet-hed"),r(_t,"rel","nofollow"),r(Po,"width","64"),P(Po.src,_d="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_hed.png")||r(Po,"src",_d),r(Co,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_hed.png"),r(xo,"width","64"),P(xo.src,vd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png")||r(xo,"src",vd),r(Do,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png"),r(vt,"href","https://huggingface.co/lllyasviel/sd-controlnet-mlsd"),r(vt,"rel","nofollow"),r(To,"width","64"),P(To.src,bd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_mlsd.png")||r(To,"src",bd),r(No,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_mlsd.png"),r(Ao,"width","64"),P(Ao.src,wd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png")||r(Ao,"src",wd),r(So,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png"),r(bt,"href","https://huggingface.co/lllyasviel/sd-controlnet-normal"),r(bt,"rel","nofollow"),r(yt,"href","https://en.wikipedia.org/wiki/Normal_mapping"),r(yt,"rel","nofollow"),r(Mo,"width","64"),P(Mo.src,yd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_normal.png")||r(Mo,"src",yd),r(Io,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_normal.png"),r(Lo,"width","64"),P(Lo.src,Ed="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png")||r(Lo,"src",Ed),r(jo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png"),r(Et,"href","https://huggingface.co/lllyasviel/sd-controlnet_openpose"),r(Et,"rel","nofollow"),r(kt,"href","https://github.com/CMU-Perceptual-Computing-Lab/openpose"),r(kt,"rel","nofollow"),r(Uo,"width","64"),P(Uo.src,$d="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_openpose.png")||r(Uo,"src",$d),r(qo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_openpose.png"),r(Go,"width","64"),P(Go.src,kd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png")||r(Go,"src",kd),r(Oo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png"),r(Ct,"href","https://huggingface.co/lllyasviel/sd-controlnet_scribble"),r(Ct,"rel","nofollow"),r(zo,"width","64"),P(zo.src,Cd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_scribble.png")||r(zo,"src",Cd),r(Fo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_scribble.png"),r(Ho,"width","64"),P(Ho.src,Pd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png")||r(Ho,"src",Pd),r(Ro,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png"),r(Dt,"href","https://huggingface.co/lllyasviel/sd-controlnet_seg"),r(Dt,"rel","nofollow"),r(Nt,"href","https://groups.csail.mit.edu/vision/datasets/ADE20K/"),r(Nt,"rel","nofollow"),r(Vo,"width","64"),P(Vo.src,Dd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_seg.png")||r(Vo,"src",Dd),r(Wo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_seg.png"),r(Ko,"width","64"),P(Ko.src,xd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png")||r(Ko,"src",xd),r(Bo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png"),r(Te,"id","diffusers.StableDiffusionControlNetPipeline"),r(Te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(Te,"href","#diffusers.StableDiffusionControlNetPipeline"),r(ne,"class","relative group"),r(Yo,"href","/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),r(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),r(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),r(Ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),r(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),r(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),r(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),r(je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),r(Le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),r(qe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),r(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,f){e(document.head,$),p(t,A,f),p(t,k,f),e(k,y),e(y,N),_(m,N,null),e(k,D),e(k,an),e(an,sr),p(t,Ra,f),p(t,Z,f),e(Z,re),e(re,rn),_(Be,rn,null),e(Z,lr),e(Z,sn),e(sn,cr),p(t,Ha,f),p(t,Ke,f),e(Ke,Ye),e(Ye,dr),e(Ke,fr),p(t,Wa,f),p(t,Bt,f),e(Bt,pr),p(t,Va,f),p(t,Kt,f),e(Kt,mr),p(t,Ba,f),p(t,Yt,f),e(Yt,ln),e(ln,hr),p(t,Ka,f),p(t,se,f),e(se,ur),e(se,Ze),e(Ze,gr),e(se,_r),p(t,Ya,f),p(t,Zt,f),e(Zt,vr),p(t,Za,f),p(t,le,f),e(le,cn),e(cn,Je),e(Je,br),e(le,wr),e(le,dn),e(dn,Qe),e(Qe,yr),p(t,Ja,f),p(t,J,f),e(J,ce),e(ce,fn),_(Xe,fn,null),e(J,Er),e(J,pn),e(pn,$r),p(t,Qa,f),p(t,de,f),e(de,mn),e(mn,Q),e(Q,hn),e(hn,kr),e(Q,Cr),e(Q,un),e(un,Pr),e(Q,Dr),e(Q,Jt),e(Jt,xr),e(de,Nr),e(de,gn),e(gn,X),e(X,_n),e(_n,et),e(et,Tr),e(X,Sr),e(X,vn),e(vn,bn),e(bn,Ar),e(X,Ir),e(X,Qt),e(Qt,tt),e(tt,Mr),p(t,Xa,f),p(t,ee,f),e(ee,fe),e(fe,wn),_(ot,wn,null),e(ee,jr),e(ee,yn),e(yn,Lr),p(t,ei,f),p(t,pe,f),e(pe,qr),e(pe,En),e(En,Ur),e(pe,Or),p(t,ti,f),p(t,me,f),e(me,$n),e($n,kn),e(kn,Cn),e(Cn,Gr),e(me,Fr),e(me,Pn),e(Pn,Xt),e(Xt,nt),e(nt,zr),e(nt,eo),e(eo,Rr),e(nt,Hr),p(t,oi,f),p(t,he,f),e(he,Wr),e(he,at),e(at,Vr),e(he,Br),p(t,ni,f),_(it,t,f),p(t,ai,f),p(t,to,f),e(to,oo),p(t,ii,f),p(t,z,f),e(z,Kr),e(z,Dn),e(Dn,Yr),e(z,Zr),e(z,no),e(no,Jr),e(z,Qr),p(t,ri,f),p(t,ao,f),e(ao,Xr),p(t,si,f),_(rt,t,f),p(t,li,f),p(t,io,f),e(io,es),p(t,ci,f),_(st,t,f),p(t,di,f),p(t,ro,f),e(ro,ts),p(t,fi,f),_(lt,t,f),p(t,pi,f),p(t,so,f),e(so,os),p(t,mi,f),p(t,lo,f),e(lo,co),p(t,hi,f),p(t,ue,f),e(ue,ns),e(ue,fo),e(fo,as),e(ue,is),p(t,ui,f),_(ct,t,f),p(t,gi,f),p(t,ge,f),e(ge,rs),e(ge,po),e(po,ss),e(ge,ls),p(t,_i,f),_(dt,t,f),p(t,vi,f),p(t,mo,f),e(mo,cs),p(t,bi,f),_(ft,t,f),p(t,wi,f),p(t,ho,f),e(ho,ds),p(t,yi,f),p(t,uo,f),e(uo,go),p(t,Ei,f),p(t,_e,f),e(_e,xn),e(xn,fs),e(_e,ps),e(_e,_o),e(_o,ms),p(t,$i,f),p(t,te,f),e(te,ve),e(ve,Nn),_(pt,Nn,null),e(te,hs),e(te,Tn),e(Tn,us),p(t,ki,f),p(t,R,f),e(R,gs),e(R,Sn),e(Sn,_s),e(R,vs),e(R,An),e(An,bs),e(R,ws),p(t,Ci,f),p(t,be,f),e(be,ys),e(be,mt),e(mt,Es),e(be,$s),p(t,Pi,f),p(t,oe,f),e(oe,we),e(we,In),_(ht,In,null),e(oe,ks),e(oe,Mn),e(Mn,Cs),p(t,Di,f),p(t,ye,f),e(ye,jn),e(jn,I),e(I,Ln),e(Ln,Ps),e(I,Ds),e(I,qn),e(qn,xs),e(I,Ns),e(I,Un),e(Un,Ts),e(I,Ss),e(I,On),e(On,As),e(ye,Is),e(ye,C),e(C,M),e(M,Ee),e(Ee,ut),e(ut,Ms),e(Ee,js),e(Ee,Ls),e(Ee,Gn),e(Gn,qs),e(M,Us),e(M,Fn),e(Fn,Os),e(M,Gs),e(M,zn),e(zn,vo),e(vo,$e),e(M,Fs),e(M,Rn),e(Rn,bo),e(bo,wo),e(C,zs),e(C,j),e(j,ke),e(ke,gt),e(gt,Rs),e(ke,Hs),e(ke,Ws),e(ke,Hn),e(Hn,Vs),e(j,Bs),e(j,Wn),e(Wn,Ks),e(j,Ys),e(j,Vn),e(Vn,yo),e(yo,Eo),e(j,Zs),e(j,Bn),e(Bn,$o),e($o,ko),e(C,Js),e(C,L),e(L,Ce),e(Ce,_t),e(_t,Qs),e(Ce,Xs),e(Ce,el),e(Ce,Kn),e(Kn,tl),e(L,ol),e(L,Yn),e(Yn,nl),e(L,al),e(L,Zn),e(Zn,Co),e(Co,Po),e(L,il),e(L,Jn),e(Jn,Do),e(Do,xo),e(C,rl),e(C,q),e(q,Pe),e(Pe,vt),e(vt,sl),e(Pe,ll),e(Pe,cl),e(Pe,Qn),e(Qn,dl),e(q,fl),e(q,Xn),e(Xn,pl),e(q,ml),e(q,ea),e(ea,No),e(No,To),e(q,hl),e(q,ta),e(ta,So),e(So,Ao),e(C,ul),e(C,U),e(U,De),e(De,bt),e(bt,gl),e(De,_l),e(De,vl),e(De,oa),e(oa,bl),e(U,wl),e(U,wt),e(wt,yl),e(wt,yt),e(yt,El),e(wt,$l),e(U,kl),e(U,na),e(na,Io),e(Io,Mo),e(U,Cl),e(U,aa),e(aa,jo),e(jo,Lo),e(C,Pl),e(C,O),e(O,xe),e(xe,Et),e(Et,Dl),e(xe,xl),e(xe,Nl),e(xe,ia),e(ia,Tl),e(O,Sl),e(O,$t),e($t,Al),e($t,kt),e(kt,Il),e($t,Ml),e(O,jl),e(O,ra),e(ra,qo),e(qo,Uo),e(O,Ll),e(O,sa),e(sa,Oo),e(Oo,Go),e(C,ql),e(C,G),e(G,Ne),e(Ne,Ct),e(Ct,Ul),e(Ne,Ol),e(Ne,Gl),e(Ne,la),e(la,Fl),e(G,zl),e(G,ca),e(ca,Rl),e(G,Hl),e(G,da),e(da,Fo),e(Fo,zo),e(G,Wl),e(G,fa),e(fa,Ro),e(Ro,Ho),e(C,Vl),e(C,F),e(F,Pt),e(Pt,Dt),e(Dt,Bl),e(Pt,Kl),e(Pt,pa),e(pa,Yl),e(F,Zl),e(F,xt),e(xt,Jl),e(xt,Nt),e(Nt,Ql),e(xt,Xl),e(F,ec),e(F,ma),e(ma,Wo),e(Wo,Vo),e(F,tc),e(F,ha),e(ha,Bo),e(Bo,Ko),p(t,xi,f),p(t,ne,f),e(ne,Te),e(Te,ua),_(Tt,ua,null),e(ne,oc),e(ne,ga),e(ga,nc),p(t,Ni,f),p(t,h,f),_(St,h,null),e(h,ac),e(h,_a),e(_a,ic),e(h,rc),e(h,At),e(At,sc),e(At,Yo),e(Yo,lc),e(At,cc),e(h,dc),e(h,H),_(It,H,null),e(H,fc),e(H,va),e(va,pc),e(H,mc),_(Se,H,null),e(h,hc),e(h,W),_(Mt,W,null),e(W,uc),e(W,ba),e(ba,gc),e(W,_c),e(W,wa),e(wa,vc),e(h,bc),e(h,Ae),_(jt,Ae,null),e(Ae,wc),e(Ae,Lt),e(Lt,yc),e(Lt,ya),e(ya,Ec),e(Lt,$c),e(h,kc),e(h,V),_(qt,V,null),e(V,Cc),e(V,Ea),e(Ea,Pc),e(V,Dc),e(V,$a),e($a,xc),e(h,Nc),e(h,Ie),_(Ut,Ie,null),e(Ie,Tc),e(Ie,Ot),e(Ot,Sc),e(Ot,ka),e(ka,Ac),e(Ot,Ic),e(h,Mc),e(h,T),_(Gt,T,null),e(T,jc),e(T,Ca),e(Ca,Lc),e(T,qc),e(T,Pa),e(Pa,Uc),e(T,Oc),e(T,Da),e(Da,Gc),e(T,Fc),_(Me,T,null),e(h,zc),e(h,je),_(Ft,je,null),e(je,Rc),e(je,xa),e(xa,Hc),e(h,Wc),e(h,Le),_(zt,Le,null),e(Le,Vc),e(Le,S),e(S,Bc),e(S,Na),e(Na,Kc),e(S,Yc),e(S,Ta),e(Ta,Zc),e(S,Jc),e(S,Sa),e(Sa,Qc),e(S,Xc),e(S,Aa),e(Aa,ed),e(S,td),e(h,od),e(h,qe),_(Rt,qe,null),e(qe,nd),e(qe,ae),e(ae,ad),e(ae,Ia),e(Ia,id),e(ae,rd),e(ae,Ma),e(Ma,sd),e(ae,ld),Ti=!0},p(t,[f]){const Ht={};f&2&&(Ht.$$scope={dirty:f,ctx:t}),Se.$set(Ht);const ja={};f&2&&(ja.$$scope={dirty:f,ctx:t}),Me.$set(ja)},i(t){Ti||(v(m.$$.fragment,t),v(Be.$$.fragment,t),v(Xe.$$.fragment,t),v(ot.$$.fragment,t),v(it.$$.fragment,t),v(rt.$$.fragment,t),v(st.$$.fragment,t),v(lt.$$.fragment,t),v(ct.$$.fragment,t),v(dt.$$.fragment,t),v(ft.$$.fragment,t),v(pt.$$.fragment,t),v(ht.$$.fragment,t),v(Tt.$$.fragment,t),v(St.$$.fragment,t),v(It.$$.fragment,t),v(Se.$$.fragment,t),v(Mt.$$.fragment,t),v(jt.$$.fragment,t),v(qt.$$.fragment,t),v(Ut.$$.fragment,t),v(Gt.$$.fragment,t),v(Me.$$.fragment,t),v(Ft.$$.fragment,t),v(zt.$$.fragment,t),v(Rt.$$.fragment,t),Ti=!0)},o(t){b(m.$$.fragment,t),b(Be.$$.fragment,t),b(Xe.$$.fragment,t),b(ot.$$.fragment,t),b(it.$$.fragment,t),b(rt.$$.fragment,t),b(st.$$.fragment,t),b(lt.$$.fragment,t),b(ct.$$.fragment,t),b(dt.$$.fragment,t),b(ft.$$.fragment,t),b(pt.$$.fragment,t),b(ht.$$.fragment,t),b(Tt.$$.fragment,t),b(St.$$.fragment,t),b(It.$$.fragment,t),b(Se.$$.fragment,t),b(Mt.$$.fragment,t),b(jt.$$.fragment,t),b(qt.$$.fragment,t),b(Ut.$$.fragment,t),b(Gt.$$.fragment,t),b(Me.$$.fragment,t),b(Ft.$$.fragment,t),b(zt.$$.fragment,t),b(Rt.$$.fragment,t),Ti=!1},d(t){o($),t&&o(A),t&&o(k),w(m),t&&o(Ra),t&&o(Z),w(Be),t&&o(Ha),t&&o(Ke),t&&o(Wa),t&&o(Bt),t&&o(Va),t&&o(Kt),t&&o(Ba),t&&o(Yt),t&&o(Ka),t&&o(se),t&&o(Ya),t&&o(Zt),t&&o(Za),t&&o(le),t&&o(Ja),t&&o(J),w(Xe),t&&o(Qa),t&&o(de),t&&o(Xa),t&&o(ee),w(ot),t&&o(ei),t&&o(pe),t&&o(ti),t&&o(me),t&&o(oi),t&&o(he),t&&o(ni),w(it,t),t&&o(ai),t&&o(to),t&&o(ii),t&&o(z),t&&o(ri),t&&o(ao),t&&o(si),w(rt,t),t&&o(li),t&&o(io),t&&o(ci),w(st,t),t&&o(di),t&&o(ro),t&&o(fi),w(lt,t),t&&o(pi),t&&o(so),t&&o(mi),t&&o(lo),t&&o(hi),t&&o(ue),t&&o(ui),w(ct,t),t&&o(gi),t&&o(ge),t&&o(_i),w(dt,t),t&&o(vi),t&&o(mo),t&&o(bi),w(ft,t),t&&o(wi),t&&o(ho),t&&o(yi),t&&o(uo),t&&o(Ei),t&&o(_e),t&&o($i),t&&o(te),w(pt),t&&o(ki),t&&o(R),t&&o(Ci),t&&o(be),t&&o(Pi),t&&o(oe),w(ht),t&&o(Di),t&&o(ye),t&&o(xi),t&&o(ne),w(Tt),t&&o(Ni),t&&o(h),w(St),w(It),w(Se),w(Mt),w(jt),w(qt),w(Ut),w(Gt),w(Me),w(Ft),w(zt),w(Rt)}}}const Dm={local:"texttoimage-generation-with-controlnet-conditioning",sections:[{local:"overview",title:"Overview"},{local:"available-pipelines",title:"Available Pipelines:"},{local:"usage-example",title:"Usage example"},{local:"available-checkpoints",sections:[{local:"controlnet-with-stable-diffusion-15",title:"ControlNet with Stable Diffusion 1.5"}],title:"Available checkpoints"},{local:"diffusers.StableDiffusionControlNetPipeline",title:"StableDiffusionControlNetPipeline"}],title:"Text-to-Image Generation with ControlNet Conditioning"};function xm(Vt){return $m(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Mm extends bm{constructor($){super();wm(this,$,xm,Pm,ym,{})}}export{Mm as default,Dm as metadata};
